diff -ruN vdr-2.3.1/recording.h vdr-2.3.2/recording.h
--- vdr-2.3.1/recording.h	2015-08-29 16:12:14.000000000 +0200
+++ vdr-2.3.2/recording.h	2016-12-13 14:12:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 4.3 2015/08/29 14:12:14 kls Exp $
+ * $Id: recording.h 4.4 2016/12/13 13:12:12 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -302,16 +302,18 @@
 
 class cRecordingsHandlerEntry;
 
-class cRecordingsHandler {
+class cRecordingsHandler : public cThread {
 private:
   cMutex mutex;
   cList<cRecordingsHandlerEntry> operations;
   bool finished;
   bool error;
   cRecordingsHandlerEntry *Get(const char *FileName);
+protected:
+  virtual void Action(void);
 public:
   cRecordingsHandler(void);
-  ~cRecordingsHandler();
+  virtual ~cRecordingsHandler();
   bool Add(int Usage, const char *FileNameSrc, const char *FileNameDst = NULL);
        ///< Adds the given FileNameSrc to the recordings handler for (later)
        ///< processing. Usage can be either ruCut, ruMove or ruCopy. FileNameDst
@@ -329,12 +331,6 @@
        ///< Deletes/terminates all operations.
   int GetUsage(const char *FileName);
        ///< Returns the usage type for the given FileName.
-  bool Active(void);
-       ///< Checks whether there is currently any operation running and starts
-       ///> the next one form the list if the previous one has finished.
-       ///< This function must be called regularly to trigger switching to the
-       ///< next operation in the list.
-       ///< Returns true if there are any operations in the list.
   bool Finished(bool &Error);
        ///< Returns true if all operations in the list have been finished.
        ///< If there have been any errors, Errors will be set to true.
diff -ruN vdr-2.3.1/remux.c vdr-2.3.2/remux.c
--- vdr-2.3.1/remux.c	2015-03-11 10:49:38.000000000 +0100
+++ vdr-2.3.2/remux.c	2016-12-22 13:58:20.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 4.1 2015/03/11 09:49:38 kls Exp $
+ * $Id: remux.c 4.3 2016/12/22 12:58:20 kls Exp $
  */
 
 #include "remux.h"
@@ -603,6 +603,7 @@
 
 void cPatPmtParser::Reset(void)
 {
+  completed = false;
   pmtSize = 0;
   patVersion = pmtVersion = -1;
   pmtPids[0] = 0;
@@ -708,6 +709,7 @@
            case 0x01: // STREAMTYPE_11172_VIDEO
            case 0x02: // STREAMTYPE_13818_VIDEO
            case 0x1B: // H.264
+           case 0x24: // H.265
                       vpid = stream.getPid();
                       vtype = stream.getStreamType();
                       ppid = Pmt.getPCRPid();
@@ -892,6 +894,7 @@
             }
          }
      pmtVersion = Pmt.getVersionNumber();
+     completed = true;
      }
   else
      esyslog("ERROR: can't parse PMT");
@@ -1204,16 +1207,16 @@
     nutSequenceParameterSet = 7,
     nutAccessUnitDelimiter  = 9,
     };
-  cTsPayload tsPayload;
   uchar byte; // holds the current byte value in case of bitwise access
   int bit; // the bit index into the current byte (-1 if we're not in bit reading mode)
   int zeroBytes; // the number of consecutive zero bytes (to detect 0x000003)
-  uint32_t scanner;
   // Identifiers written in '_' notation as in "ITU-T H.264":
   bool separate_colour_plane_flag;
   int log2_max_frame_num;
   bool frame_mbs_only_flag;
-  //
+protected:
+  cTsPayload tsPayload;
+  uint32_t scanner;
   bool gotAccessUnitDelimiter;
   bool gotSequenceParameterSet;
   uchar GetByte(bool Raw = false);
@@ -1430,6 +1433,81 @@
      }
 }
 
+// --- cH265Parser -----------------------------------------------------------
+
+class cH265Parser : public cH264Parser {
+private:
+  enum eNalUnitType {
+    nutSliceSegmentTrailingN =  0,
+    nutSliceSegmentTrailingR =  1,
+    nutSliceSegmentTSAN      =  2,
+    nutSliceSegmentTSAR      =  3,
+    nutSliceSegmentSTSAN     =  4,
+    nutSliceSegmentSTSAR     =  5,
+    nutSliceSegmentRADLN     =  6,
+    nutSliceSegmentRADLR     =  7,
+    nutSliceSegmentRASLN     =  8,
+    nutSliceSegmentRASLR     =  9,
+    nutSliceSegmentBLAWLP    = 16,
+    nutSliceSegmentBLAWRADL  = 17,
+    nutSliceSegmentBLANLP    = 18,
+    nutSliceSegmentIDRWRADL  = 19,
+    nutSliceSegmentIDRNLP    = 20,
+    nutSliceSegmentCRANUT    = 21,
+    nutVideoParameterSet     = 32,
+    nutSequenceParameterSet  = 33,
+    nutPictureParameterSet   = 34,
+    nutAccessUnitDelimiter   = 35,
+    nutEndOfSequence         = 36,
+    nutEndOfBitstream        = 37,
+    nutFillerData            = 38,
+    nutPrefixSEI             = 39,
+    nutSuffixSEI             = 40,
+    nutNonVCLRes0            = 41,
+    nutNonVCLRes3            = 44,
+    nutUnspecified0          = 48,
+    nutUnspecified7          = 55,
+    };
+public:
+  cH265Parser(void);
+  virtual int Parse(const uchar *Data, int Length, int Pid);
+  };
+
+cH265Parser::cH265Parser(void)
+:cH264Parser()
+{
+}
+
+int cH265Parser::Parse(const uchar *Data, int Length, int Pid)
+{
+  newFrame = independentFrame = false;
+  tsPayload.Setup(const_cast<uchar *>(Data), Length, Pid);
+  if (TsPayloadStart(Data)) {
+     tsPayload.SkipPesHeader();
+     scanner = EMPTY_SCANNER;
+     }
+  for (;;) {
+      scanner = (scanner << 8) | GetByte(true);
+      if ((scanner & 0xFFFFFF00) == 0x00000100) { // NAL unit start
+         uchar NalUnitType = (scanner >> 1) & 0x3F;
+         GetByte(); // nuh_layer_id + nuh_temporal_id_plus1
+         if (NalUnitType <= nutSliceSegmentRASLR || (NalUnitType >= nutSliceSegmentBLAWLP && NalUnitType <= nutSliceSegmentCRANUT)) {
+            if (NalUnitType == nutSliceSegmentIDRWRADL || NalUnitType == nutSliceSegmentIDRNLP || NalUnitType == nutSliceSegmentCRANUT)
+               independentFrame = true;
+            if (GetBit()) { // first_slice_segment_in_pic_flag
+               newFrame = true;
+               tsPayload.Statistics();
+               }
+            break;
+            }
+         }
+      if (tsPayload.AtPayloadStart() // stop at any new payload start to have the buffer refilled if necessary
+         || tsPayload.Eof()) // or if we're out of data
+         break;
+      }
+  return tsPayload.Used();
+}
+
 // --- cFrameDetector --------------------------------------------------------
 
 cFrameDetector::cFrameDetector(int Pid, int Type)
@@ -1456,14 +1534,16 @@
 {
   pid = Pid;
   type = Type;
-  isVideo = type == 0x01 || type == 0x02 || type == 0x1B; // MPEG 1, 2 or H.264
+  isVideo = type == 0x01 || type == 0x02 || type == 0x1B || type == 0x24; // MPEG 1, 2, H.264 or H.265
   delete parser;
   parser = NULL;
   if (type == 0x01 || type == 0x02)
      parser = new cMpeg2Parser;
   else if (type == 0x1B)
      parser = new cH264Parser;
-  else if (type == 0x04 || type == 0x06) // MPEG audio or AC3 audio
+  else if (type == 0x24)
+     parser = new cH265Parser;
+  else if (type == 0x03 || type == 0x04 || type == 0x06) // MPEG audio or AC3 audio
      parser = new cAudioParser;
   else if (type != 0)
      esyslog("ERROR: unknown stream type %d (PID %d) in frame detector", type, pid);
diff -ruN vdr-2.3.1/remux.h vdr-2.3.2/remux.h
--- vdr-2.3.1/remux.h	2014-03-22 15:58:24.000000000 +0100
+++ vdr-2.3.2/remux.h	2016-12-22 14:09:54.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 4.0 2014/03/22 14:58:24 kls Exp $
+ * $Id: remux.h 4.1 2016/12/22 13:09:54 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -361,6 +361,7 @@
   uint16_t compositionPageIds[MAXSPIDS];
   uint16_t ancillaryPageIds[MAXSPIDS];
   bool updatePrimaryDevice;
+  bool completed;
 protected:
   int SectionLength(const uchar *Data, int Length) { return (Length >= 3) ? ((int(Data[1]) & 0x0F) << 8)| Data[2] : 0; }
 public:
@@ -397,6 +398,8 @@
   int Vtype(void) const { return vtype; }
        ///< Returns the video stream type as defined by the current PMT, or 0 if no video
        ///< stream type has been detected, yet.
+  bool Completed(void) { return completed; }
+       ///< Returns true if the PMT has been completely parsed.
   const int *Apids(void) const { return apids; }
   const int *Dpids(void) const { return dpids; }
   const int *Spids(void) const { return spids; }
diff -ruN vdr-2.3.1/ringbuffer.c vdr-2.3.2/ringbuffer.c
--- vdr-2.3.1/ringbuffer.c	2012-09-22 13:26:49.000000000 +0200
+++ vdr-2.3.2/ringbuffer.c	2016-12-22 11:26:13.000000000 +0100
@@ -7,7 +7,7 @@
  * Parts of this file were inspired by the 'ringbuffy.c' from the
  * LinuxDVB driver (see linuxtv.org).
  *
- * $Id: ringbuffer.c 4.0 2012/09/22 11:26:49 kls Exp $
+ * $Id: ringbuffer.c 4.1 2016/12/22 10:26:13 kls Exp $
  */
 
 #include "ringbuffer.h"
@@ -390,12 +390,13 @@
 
 // --- cFrame ----------------------------------------------------------------
 
-cFrame::cFrame(const uchar *Data, int Count, eFrameType Type, int Index, uint32_t Pts)
+cFrame::cFrame(const uchar *Data, int Count, eFrameType Type, int Index, uint32_t Pts, bool Independent)
 {
   count = abs(Count);
   type = Type;
   index = Index;
   pts = Pts;
+  independent = Type == ftAudio ? true : Independent;
   if (Count < 0)
      data = (uchar *)Data;
   else {
diff -ruN vdr-2.3.1/ringbuffer.h vdr-2.3.2/ringbuffer.h
--- vdr-2.3.1/ringbuffer.h	2013-02-16 16:20:37.000000000 +0100
+++ vdr-2.3.2/ringbuffer.h	2016-12-22 11:26:13.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ringbuffer.h 4.0 2013/02/16 15:20:37 kls Exp $
+ * $Id: ringbuffer.h 4.1 2016/12/22 10:26:13 kls Exp $
  */
 
 #ifndef __RINGBUFFER_H
@@ -113,8 +113,9 @@
   eFrameType type;
   int index;
   uint32_t pts;
+  bool independent;
 public:
-  cFrame(const uchar *Data, int Count, eFrameType = ftUnknown, int Index = -1, uint32_t Pts = 0);
+  cFrame(const uchar *Data, int Count, eFrameType = ftUnknown, int Index = -1, uint32_t Pts = 0, bool independent = false);
     ///< Creates a new cFrame object.
     ///< If Count is negative, the cFrame object will take ownership of the given
     ///< Data. Otherwise it will allocate Count bytes of memory and copy Data.
@@ -124,6 +125,7 @@
   eFrameType Type(void) const { return type; }
   int Index(void) const { return index; }
   uint32_t Pts(void) const { return pts; }
+  bool Independent(void) const { return independent; }
   };
 
 class cRingBufferFrame : public cRingBuffer {
diff -ruN vdr-2.3.1/skinclassic.c vdr-2.3.2/skinclassic.c
--- vdr-2.3.1/skinclassic.c	2013-03-03 16:26:09.000000000 +0100
+++ vdr-2.3.2/skinclassic.c	2016-12-22 15:07:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 4.0 2013/03/03 15:26:09 kls Exp $
+ * $Id: skinclassic.c 4.1 2016/12/22 14:07:04 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -352,8 +352,7 @@
   const cFont *font = cFont::GetFont(fontOsd);
   int y = y2;
   cTextScroller ts;
-  char t[32];
-  snprintf(t, sizeof(t), "%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
+  cString t = cString::sprintf("%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
   ts.Set(osd, x1, y, x2 - x1, y3 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
   if (Event->Vps() && Event->Vps() != Event->StartTime()) {
      cString buffer = cString::sprintf(" VPS: %s ", *Event->GetVpsString());
diff -ruN vdr-2.3.1/skinlcars.c vdr-2.3.2/skinlcars.c
--- vdr-2.3.1/skinlcars.c	2015-09-01 12:07:07.000000000 +0200
+++ vdr-2.3.2/skinlcars.c	2016-12-22 15:05:56.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinlcars.c 4.1 2015/09/01 10:07:07 kls Exp $
+ * $Id: skinlcars.c 4.2 2016/12/22 14:05:56 kls Exp $
  */
 
 // "Star Trek: The Next Generation"(R) is a registered trademark of Paramount Pictures,
@@ -1636,8 +1636,7 @@
   int xl = xi00;
   int y = yi00;
   cTextScroller ts;
-  char t[32];
-  snprintf(t, sizeof(t), "%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
+  cString t = cString::sprintf("%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
   ts.Set(osd, xl, y, xi01 - xl, yi01 - y, t, font, Theme.Color(clrEventTime), Theme.Color(clrBackground));
   if (Event->Vps() && Event->Vps() != Event->StartTime()) {
      cString buffer = cString::sprintf(" VPS: %s ", *Event->GetVpsString());
diff -ruN vdr-2.3.1/skinsttng.c vdr-2.3.2/skinsttng.c
--- vdr-2.3.1/skinsttng.c	2013-11-15 16:33:14.000000000 +0100
+++ vdr-2.3.2/skinsttng.c	2016-12-22 15:07:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 4.0 2013/11/15 15:33:14 kls Exp $
+ * $Id: skinsttng.c 4.1 2016/12/22 14:07:22 kls Exp $
  */
 
 // "Star Trek: The Next Generation"(R) is a registered trademark of Paramount Pictures
@@ -655,8 +655,7 @@
   int xl = x3 + TextSpacing;
   int y = y3;
   cTextScroller ts;
-  char t[32];
-  snprintf(t, sizeof(t), "%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
+  cString t = cString::sprintf("%s  %s - %s", *Event->GetDateString(), *Event->GetTimeString(), *Event->GetEndTimeString());
   ts.Set(osd, xl, y, x4 - xl, y4 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
   if (Event->Vps() && Event->Vps() != Event->StartTime()) {
      cString buffer = cString::sprintf(" VPS: %s ", *Event->GetVpsString());
diff -ruN vdr-2.3.1/sources.conf vdr-2.3.2/sources.conf
--- vdr-2.3.1/sources.conf	2015-02-18 10:33:19.000000000 +0100
+++ vdr-2.3.2/sources.conf	2016-12-22 14:31:45.000000000 +0100
@@ -51,6 +51,7 @@
 S53E    Express AM22
 S56E    DirecTV 1R
 S57E    NSS 12
+S58.5E  Kazsat 3
 S60E    Intelsat 904
 S62E    Intelsat 902
 S64E    Intelsat 906
@@ -109,80 +110,80 @@
 S180E   Intelsat 18
 S177W   NSS 9
 
-# Atlantic
-
-S0.8W   Intelsat 10-02
-S1W     Thor 5/6
-S4W     Amos 2/3
-S5W     Eutelsat 5 West A
-S7W     Nilesat 101/201 & Eutelsat 7 West A
-S8W     Eutelsat 8 West A/C
-S11W    Express AM44
-S12.5W  Eutelsat 12 West A
-S14W    Express A4
-S15W    Telstar 12
-S18W    Intelsat 901
-S20W    NSS 7
-S22W    SES 4
-S24.5W  Intelsat 905
-S27.5W  Intelsat 907
-S30W    Hispasat 1D/1E
-S31.5W  Intelsat 25
-S34.5W  Intelsat 903
-S37.5W  NSS 10 & Telstar 11N
-S40.5W  SES 6
-S43W    Intelsat 11
-S45W    Intelsat 14
-S50W    Intelsat 1R
-S53W    Intelsat 23
-S55.5W  Intelsat 805
-S58W    Intelsat 21
-S61W    Amazonas 2/3
-
 # America
 
-S61.5W  Echostar 16
-S63W    Telstar 14R
-S65W    Star One C1
-S67W    AMC 4
-S70W    Star One C2
-S72W    AMC 6
-S72.7W  Nimiq 5
-S75W    Star One C3
-S77W    QuetzSat 1
-S82W    Nimiq 4
-S83W    AMC 9
-S84W    Brasilsat B4
+S139W   AMC 8
+S137W   AMC 7
+S135W   AMC 10
+S133W   Galaxy 15
+S131W   AMC 11
+S129W   Ciel 2
+S127W   Galaxy 13/Horizons 1
+S125W   Galaxy 14 & AMC 21
+S123W   Galaxy 18
+S121W   Echostar 9/Galaxy 23
+S119W   Echostar 14 & DirecTV 7S
+S118.8W Anik F3
+S116.8W SatMex 8
+S114.9W SatMex 5
+S113W   SatMex 6
+S111.1W Anik F2
+S110W   DirecTV 5 & Echostar 10/11
+S107.3W Anik F1R/G1
+S105W   AMC 15/18
+S103W   AMC 1
+S101W   DirecTV 4S/8 & SES 1
+S99.2W  Galaxy 16
+S97W    Galaxy 19
+S95W    Galaxy 3C
+S93.1W  Galaxy 25
+S91W    Galaxy 17 & Nimiq 6
+S89W    Galaxy 28
+S87W    SES 2
 S85W    AMC 16
 S85.1W  XM 3
-S87W    SES 2
-S89W    Galaxy 28
-S91W    Galaxy 17 & Nimiq 6
-S93.1W  Galaxy 25
-S95W    Galaxy 3C
-S97W    Galaxy 19
-S99.2W  Galaxy 16
-S101W   DirecTV 4S/8 & SES 1
-S103W   AMC 1
-S105W   AMC 15/18
-S107.3W Anik F1R/G1
-S110W   DirecTV 5 & Echostar 10/11
-S111.1W Anik F2
-S113W   SatMex 6
-S114.9W SatMex 5
-S116.8W SatMex 8
-S118.8W Anik F3
-S119W   Echostar 14 & DirecTV 7S
-S121W   Echostar 9/Galaxy 23
-S123W   Galaxy 18
-S125W   Galaxy 14 & AMC 21
-S127W   Galaxy 13/Horizons 1
-S129W   Ciel 2
-S131W   AMC 11
-S133W   Galaxy 15
-S135W   AMC 10
-S137W   AMC 7
-S139W   AMC 8
+S84W    Brasilsat B4
+S83W    AMC 9
+S82W    Nimiq 4
+S77W    QuetzSat 1
+S75W    Star One C3
+S72W    AMC 6
+S72.7W  Nimiq 5
+S70W    Star One C2
+S67W    AMC 4
+S65W    Star One C1
+S63W    Telstar 14R
+S61.5W  Echostar 16
+
+# Atlantic
+
+S61W    Amazonas 2/3
+S58W    Intelsat 21
+S55.5W  Intelsat 805
+S53W    Intelsat 23
+S50W    Intelsat 1R
+S45W    Intelsat 14
+S43W    Intelsat 11
+S40.5W  SES 6
+S37.5W  NSS 10 & Telstar 11N
+S34.5W  Intelsat 903
+S31.5W  Intelsat 25
+S30W    Hispasat 1D/1E
+S27.5W  Intelsat 907
+S24.5W  Intelsat 905
+S22W    SES 4
+S20W    NSS 7
+S18W    Intelsat 901
+S15W    Telstar 12
+S14W    Express A4
+S12.5W  Eutelsat 12 West A
+S11W    Express AM44
+S8W     Eutelsat 8 West A/C
+S7W     Nilesat 101/201 & Eutelsat 7 West A
+S5W     Eutelsat 5 West A
+S4W     Amos 2/3
+S1W     Thor 5/6
+S0.8W   Intelsat 10-02
 
 S360E   Any satellite
 
diff -ruN vdr-2.3.1/svdrp.c vdr-2.3.2/svdrp.c
--- vdr-2.3.1/svdrp.c	2015-09-14 15:23:06.000000000 +0200
+++ vdr-2.3.2/svdrp.c	2016-12-08 11:48:53.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 4.9 2015/09/14 13:23:06 kls Exp $
+ * $Id: svdrp.c 4.11 2016/12/08 10:48:53 kls Exp $
  */
 
 #include "svdrp.h"
@@ -1228,6 +1228,10 @@
               int n = Channels->GetNextNormal(CurrentChannel->Index());
               if (n < 0)
                  n = Channels->GetPrevNormal(CurrentChannel->Index());
+              if (n < 0) {
+                 Reply(501, "Can't delete channel \"%s\" - list would be empty", Option);
+                 return;
+                 }
               CurrentChannel = Channels->Get(n);
               CurrentChannelNr = 0; // triggers channel switch below
               }
@@ -1240,7 +1244,7 @@
               if (!cDevice::PrimaryDevice()->Replaying() || cDevice::PrimaryDevice()->Transferring())
                  Channels->SwitchTo(CurrentChannel->Number());
               else
-                 cDevice::SetCurrentChannel(CurrentChannel);
+                 cDevice::SetCurrentChannel(CurrentChannel->Number());
               }
            Reply(250, "Channel \"%s\" deleted", Option);
            }
@@ -1899,7 +1903,7 @@
                        if (!cDevice::PrimaryDevice()->Replaying() || cDevice::PrimaryDevice()->Transferring())
                           Channels->SwitchTo(CurrentChannel->Number());
                        else
-                          cDevice::SetCurrentChannel(CurrentChannel);
+                          cDevice::SetCurrentChannel(CurrentChannel->Number());
                        }
                     isyslog("SVDRP < %s channel %d moved to %d", *connection, FromNumber, ToNumber);
                     Reply(250,"Channel \"%d\" moved to \"%d\"", From, To);
diff -ruN vdr-2.3.1/thread.c vdr-2.3.2/thread.c
--- vdr-2.3.1/thread.c	2015-08-29 16:43:03.000000000 +0200
+++ vdr-2.3.2/thread.c	2016-12-08 10:45:25.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 4.1 2015/08/29 14:43:03 kls Exp $
+ * $Id: thread.c 4.2 2016/12/08 09:45:25 kls Exp $
  */
 
 #include "thread.h"
@@ -151,6 +151,8 @@
 
 cRwLock::cRwLock(bool PreferWriter)
 {
+  locked = 0;
+  writeLockThreadId = 0;
   pthread_rwlockattr_t attr;
   pthread_rwlockattr_init(&attr);
   pthread_rwlockattr_setkind_np(&attr, PreferWriter ? PTHREAD_RWLOCK_PREFER_WRITER_NP : PTHREAD_RWLOCK_PREFER_READER_NP);
@@ -170,8 +172,15 @@
      if (!GetAbsTime(&abstime, TimeoutMs))
         TimeoutMs = 0;
      }
-  if (Write)
+  if (Write) {
      Result = TimeoutMs ? pthread_rwlock_timedwrlock(&rwlock, &abstime) : pthread_rwlock_wrlock(&rwlock);
+     if (Result == 0)
+        writeLockThreadId = cThread::ThreadId();
+     }
+  else if (writeLockThreadId == cThread::ThreadId()) {
+     locked++; // there can be any number of stacked read locks, so we keep track here
+     Result = 0; // aquiring a read lock while holding a write lock within the same thread is OK
+     }
   else
      Result = TimeoutMs ? pthread_rwlock_timedrdlock(&rwlock, &abstime) : pthread_rwlock_rdlock(&rwlock);
   return Result == 0;
@@ -179,6 +188,13 @@
 
 void cRwLock::Unlock(void)
 {
+  if (writeLockThreadId == cThread::ThreadId()) { // this is the thread that obtained the initial write lock
+     if (locked) { // this is the unlock of a read lock within the write lock
+        locked--;
+        return;
+        }
+     }
+  writeLockThreadId = 0;
   pthread_rwlock_unlock(&rwlock);
 }
 
@@ -206,8 +222,8 @@
 
 void cMutex::Unlock(void)
 {
- if (!--locked)
-    pthread_mutex_unlock(&mutex);
+  if (!--locked)
+     pthread_mutex_unlock(&mutex);
 }
 
 // --- cThread ---------------------------------------------------------------
@@ -474,9 +490,11 @@
   if (StateKey.write && IncState && !explicitModify)
      state++;
   StateKey.state = state;
-  StateKey.write = false;
-  threadId = 0;
-  explicitModify = false;
+  if (StateKey.write) {
+     StateKey.write = false;
+     threadId = 0;
+     explicitModify = false;
+     }
   rwLock.Unlock();
 }
 
diff -ruN vdr-2.3.1/thread.h vdr-2.3.2/thread.h
--- vdr-2.3.1/thread.h	2015-08-17 15:06:24.000000000 +0200
+++ vdr-2.3.2/thread.h	2016-12-08 10:11:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 4.1 2015/08/17 13:06:24 kls Exp $
+ * $Id: thread.h 4.2 2016/12/08 09:11:24 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -14,6 +14,8 @@
 #include <stdio.h>
 #include <sys/types.h>
 
+typedef pid_t tThreadId;
+
 class cCondWait {
 private:
   pthread_mutex_t mutex;
@@ -53,6 +55,8 @@
 class cRwLock {
 private:
   pthread_rwlock_t rwlock;
+  int locked;
+  tThreadId writeLockThreadId;
 public:
   cRwLock(bool PreferWriter = false);
   ~cRwLock();
@@ -72,8 +76,6 @@
   void Unlock(void);
   };
 
-typedef pid_t tThreadId;
-
 class cThread {
   friend class cThreadLock;
 private:
diff -ruN vdr-2.3.1/timers.c vdr-2.3.2/timers.c
--- vdr-2.3.1/timers.c	2015-09-13 15:10:24.000000000 +0200
+++ vdr-2.3.2/timers.c	2016-12-23 10:48:39.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 4.5 2015/09/13 13:10:24 kls Exp $
+ * $Id: timers.c 4.7 2016/12/23 09:48:39 kls Exp $
  */
 
 #include "timers.h"
@@ -748,9 +748,9 @@
   return NULL;
 }
 
-cTimer *cTimers::GetTimer(cTimer *Timer)
+const cTimer *cTimers::GetTimer(const cTimer *Timer) const
 {
-  for (cTimer *ti = First(); ti; ti = Next(ti)) {
+  for (const cTimer *ti = First(); ti; ti = Next(ti)) {
       if (!ti->Remote() &&
           ti->Channel() == Timer->Channel() &&
           (ti->WeekDays() && ti->WeekDays() == Timer->WeekDays() || !ti->WeekDays() && ti->Day() == Timer->Day()) &&
diff -ruN vdr-2.3.1/timers.h vdr-2.3.2/timers.h
--- vdr-2.3.1/timers.h	2015-09-09 12:40:24.000000000 +0200
+++ vdr-2.3.2/timers.h	2016-12-23 10:49:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.h 4.3 2015/09/09 10:40:24 kls Exp $
+ * $Id: timers.h 4.6 2016/12/23 09:49:31 kls Exp $
  */
 
 #ifndef __TIMERS_H
@@ -122,7 +122,7 @@
   cTimers(void);
   static const cTimers *GetTimersRead(cStateKey &StateKey, int TimeoutMs = 0);
       ///< Gets the list of timers for read access. If TimeoutMs is given,
-      ///< it will wait that long to get a write lock before giving up.
+      ///< it will wait that long to get a read lock before giving up.
       ///< Otherwise it will wait indefinitely. If no read lock can be
       ///< obtained within the given timeout, NULL will be returned.
       ///< The list is locked and a pointer to it is returned if the state
@@ -170,7 +170,8 @@
   static int NewTimerId(void);
   const cTimer *GetById(int Id) const;
   cTimer *GetById(int Id) { return const_cast<cTimer *>(static_cast<const cTimers *>(this)->GetById(Id)); };
-  cTimer *GetTimer(cTimer *Timer);
+  const cTimer *GetTimer(const cTimer *Timer) const;
+  cTimer *GetTimer(const cTimer *Timer) { return const_cast<cTimer *>(static_cast<const cTimers *>(this)->GetTimer(Timer)); };
   const cTimer *GetMatch(time_t t) const;
   cTimer *GetMatch(time_t t) { return const_cast<cTimer *>(static_cast<const cTimers *>(this)->GetMatch(t)); };
   const cTimer *GetMatch(const cEvent *Event, eTimerMatch *Match = NULL) const;
diff -ruN vdr-2.3.1/tools.c vdr-2.3.2/tools.c
--- vdr-2.3.1/tools.c	2015-09-10 15:17:55.000000000 +0200
+++ vdr-2.3.2/tools.c	2016-12-23 15:03:40.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 4.4 2015/09/10 13:17:55 kls Exp $
+ * $Id: tools.c 4.5 2016/12/23 14:03:40 kls Exp $
  */
 
 #include "tools.h"
@@ -2272,6 +2272,44 @@
   free(a);
 }
 
+// --- cDynamicBuffer --------------------------------------------------------
+
+cDynamicBuffer::cDynamicBuffer(int InitialSize)
+{
+  initialSize = InitialSize;
+  buffer = NULL;
+  size = used = 0;
+}
+
+cDynamicBuffer::~cDynamicBuffer()
+{
+  free(buffer);
+}
+
+bool cDynamicBuffer::Realloc(int NewSize)
+{
+  if (size < NewSize) {
+     NewSize = max(NewSize, size ? size * 3 / 2 : initialSize); // increase size by at least 50%
+     if (uchar *NewBuffer = (uchar *)realloc(buffer, NewSize)) {
+        buffer = NewBuffer;
+        size = NewSize;
+        }
+     else {
+        esyslog("ERROR: out of memory");
+        return false;
+        }
+     }
+  return true;
+}
+
+void cDynamicBuffer::Append(const uchar *Data, int Length)
+{
+  if (Assert(used + Length)) {
+     memcpy(buffer + used, Data, Length);
+     used += Length;
+     }
+}
+
 // --- cHashBase -------------------------------------------------------------
 
 cHashBase::cHashBase(int Size)
diff -ruN vdr-2.3.1/tools.h vdr-2.3.2/tools.h
--- vdr-2.3.1/tools.h	2015-09-06 12:45:54.000000000 +0200
+++ vdr-2.3.2/tools.h	2016-12-23 14:56:35.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 4.3 2015/09/06 10:45:54 kls Exp $
+ * $Id: tools.h 4.5 2016/12/23 13:56:35 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -609,7 +609,7 @@
     else \
        list = c##Class::Get##Name##Read(stateKey); \
   } \
-  ~c##Name##Lock() { stateKey.Remove(); } \
+  ~c##Name##Lock() { if (list) stateKey.Remove(); } \
   const c##Class *Name(void) const { return list; } \
   c##Class *Name(void) { return const_cast<c##Class *>(list); } \
   }
@@ -775,6 +775,26 @@
   bool Load(const char *Directory, bool DirsOnly = false);
   };
 
+class cDynamicBuffer {
+private:
+  uchar *buffer;
+  int initialSize;
+  int size; // the total size of the buffer (bytes in memory)
+  int used; // the number of used bytes, starting at the beginning of the buffer
+  bool Realloc(int NewSize);
+  bool Assert(int NewSize) { return size < NewSize ? Realloc(NewSize) : true; } // inline for performance!
+public:
+  cDynamicBuffer(int InitialSize = 1024);
+  ~cDynamicBuffer();
+  void Append(const uchar *Data, int Length);
+  void Append(uchar Data) { if (Assert(used + 1)) buffer[used++] = Data; }
+  void Set(int Index, uchar Data) { if (Assert(Index + 1)) buffer[Index] = Data; }
+  uchar Get(int Index) { return Index < used ? buffer[Index] : 0; }
+  void Clear(void) { used = 0; }
+  uchar *Data(void) { return buffer; }
+  int Length(void) { return used; }
+  };
+
 class cHashObject : public cListObject {
   friend class cHashBase;
 private:
diff -ruN vdr-2.3.1/vdr.c vdr-2.3.2/vdr.c
--- vdr-2.3.1/vdr.c	2015-09-11 10:02:50.000000000 +0200
+++ vdr-2.3.2/vdr.c	2016-12-23 15:34:37.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 4.7 2015/09/11 08:02:50 kls Exp $
+ * $Id: vdr.c 4.9 2016/12/23 14:34:37 kls Exp $
  */
 
 #include <getopt.h>
@@ -171,6 +171,9 @@
   // Something terrible must have happened that prevented the 'alarm()' from
   // being called in time, so let's get out of here:
   esyslog("PANIC: watchdog timer expired - exiting!");
+#ifdef SDNOTIFY
+  sd_notify(0, "STOPPING=1\nSTATUS=PANIC");
+#endif
   exit(1);
 }
 
@@ -235,6 +238,10 @@
 #if defined(VDR_USER)
   VdrUser = VDR_USER;
 #endif
+#ifdef SDNOTIFY
+  time_t SdWatchdog;
+  int SdWatchdogTimeout = 0;
+#endif
 
   cArgs *Args = NULL;
   if (argc == 1) {
@@ -914,6 +921,16 @@
      }
 
 #ifdef SDNOTIFY
+  if (sd_watchdog_enabled(0, NULL) > 0) {
+     uint64_t timeout;
+     SdWatchdog = time(NULL);
+     sd_watchdog_enabled(0, &timeout);
+     SdWatchdogTimeout = (int)timeout/1000000;
+     dsyslog("SD_WATCHDOG enabled with timeout set to %d seconds", SdWatchdogTimeout);
+     }
+
+  // Startup notification:
+
   sd_notify(0, "READY=1\nSTATUS=Ready");
 #endif
 
@@ -976,6 +993,14 @@
               dsyslog("max. latency time %d seconds", MaxLatencyTime);
               }
            }
+#ifdef SDNOTIFY
+        // Ping systemd watchdog when half the timeout is elapsed:
+        if (SdWatchdogTimeout && (Now - SdWatchdog) * 2 > SdWatchdogTimeout) {
+           sd_notify(0, "WATCHDOG=1");
+           SdWatchdog = Now;
+           dsyslog("SD_WATCHDOG ping");
+           }
+#endif
         // Handle channel and timer modifications:
         {
           // Channels and timers need to be stored in a consistent manner,
@@ -1480,9 +1505,6 @@
               ShutdownHandler.countdown.Cancel();
            }
 
-        // Keep the recordings handler alive:
-        RecordingsHandler.Active();
-
         if ((Now - LastInteract) > ACTIVITYTIMEOUT && !cRecordControls::Active() && !RecordingsHandler.Active() && (Now - cRemote::LastActivity()) > ACTIVITYTIMEOUT) {
            // Handle housekeeping tasks
 
@@ -1568,5 +1590,11 @@
      closelog();
   if (HasStdin)
      tcsetattr(STDIN_FILENO, TCSANOW, &savedTm);
+#ifdef SDNOTIFY
+  if (ShutdownHandler.GetExitCode() == 2)
+     sd_notify(0, "STOPPING=1\nSTATUS=Startup failed, exiting");
+  else
+     sd_notify(0, "STOPPING=1\nSTATUS=Exiting");
+#endif
   return ShutdownHandler.GetExitCode();
 }
